Subject: Re: [sipcore] Content-Disposition questions - errata suggestion
From: Paul Kyzivat <[email-masked]>
To: "Dale R. Worley" <[email-masked]>, Christer Holmberg <[email-masked]>
Cc: [email-masked]
Date: Thu, 3 Dec 2015 10:34:19 -0500
List-Id: SIP Core Working Group <sipcore.ietf.org>

On 12/3/15 9:36 AM, Dale R. Worley wrote:
> Christer Holmberg <[email-masked]> writes:
>> There were two issues:
>>
>> Issue 1)	Is the default handling value "required" also if the C-D header field is not present?
>> Issue 2)	Different MIME types seem to assume different default disposition types values.
>>
>> In this e-mail I focus on issue 1).
>> [...]
>> NEW TEXT:
>>                "The handling parameter, handling-param, describes how the UAS should
>>                react if it receives a message body whose content type or disposition
>>                type it does not understand.  The parameter has defined values of
>>                "optional" and "required".  If the handling parameter is missing, or if
>>                 the Content-Disposition header field is missing, the value "required"
>>                 MUST be assumed.  The handling parameter is described in RFC 3204 [19]."
>
> That erratum makes sense to me.  It seems to document what the original
> intention was.

Agree, except see below.

> The biggest change is changing SHOULD to MUST, but I
> don't see a problem with that.

I'm undecided on that, and would like to discuss.

Right now, if C-D is present, but 'handling' is missing then "required" 
*SHOULD* be assumed. That of course begs the question of when it would 
be appropriate to ignore the SHOULD.

If there are any valid reasons, then ISTM that they would probably also 
apply when the C-D is missing.

So the real question is what, if any, conditions justify violating the 
SHOULD?

> In regard to issue 2, I don't see a problem.
>
> Either the UA "understands" the particular MIME type or not.
>      If it does, the UA checks for Content-Disposition.
>          If Content-Disposition is present, the disp-type determines the
>              handling.
>          If Content-Disposition is not present, UA uses the default handling for
>              the MIME type.
>      If it does not, the UA checks whether handling=optional is present.
>          If it is present, the UA ignores the body part.
>          If it is not present, the UA rejects the request.
>
> However, I am assuming that the "default content disposition" is purely
> a disp-type (i.e., render, session, etc.), and does not include a
> handling-param.

I think I agree. The alternative would be that the default disposition 
for a mime type includes a default for the handling value. (That might 
be a reason for SHOULD rather than MUST above.)

But that is nonsense. To know the default disposition for a mime type 
you must understand the mime type. And if you understand it, then the 
handling parameter is irrelevant to you.

We may need to investigate the history of this parameter to understand 
the intent. I was thinking it went back to MIME. But after cursory 
searching, the earliest reference I have found is in RFC3204. That 
predates 3261. It doesn't say SHOULD. Rather, it says:

    If the handling parameter is missing, the value "required" is to be
    assumed.

That isn't normative, but it sounds like MUST.

	Thanks,
	Paul